#!/usr/bin/env node


const fs = require("fs");
const path = require("path");
const creat_argv = require("nv-cli-basic");

const {pairl2d,fshow} = require("nv-facutil-basic");

const _eng = require("./index");


const cfg = {
    alias: {
        'dbname'          :'N',
        'tblname'         :'t', 
        'desc'            :'D', 
        'cond'            :'c',   
        'srch_ptrn'       :'s',
        'oper'            :'o',
        'list'            :'l',
        'action'          :'a', 
        'offset'          :'O',
        'limit'           :'L',
        'order_by'        :'r',
        'slct_cols'       :'C',
        'total'           :'T',
        'help'            :'h',
    },
    description: {
        'dbname'          :'database name',
        'tblname'         :'table name',
        'desc'            :'desc name,default ___dflt___',
        'cond'            :'js-style condition where str ,refer to nv-pg-ir, default null',
        'srch_ptrn'       :'full text srch ptrn,default "" ', 
        'oper'            :'OR|AND ,cond <binop> srch_ptrn,default AND',
        'list'            :'list avaliable actions',
        'action'          :'action,default select_with_match',
        'offset'          :'offset,default 0',
        'limit'           :'limit of one batch,default 1024',
        'order_by'        :'order by, default none',
        'slct_cols'       :'slcted colnames,default all',
        'total'           :'total wanted,default Infinity/all',
        'help':"usage",
    },
    string:["desc","srch_ptrn","oper","cond","tbl","action"],
    boolean: ["help","list"],
    defaults: {
        desc:"___dflt___",
        cond:null,
        srch_ptrn:"",
        oper:"AND",
        action:"select_with_match",
        offset:0,
        limit:1024,
        total:null,
    }
}



var argv = creat_argv(cfg);
////

if(argv.h) {
    var _usage = argv.usage("nv_pg_nofix_select");
    console.log(_usage)
} else {
    let p;
    if(argv.l) {
        console.log(Object.keys(_eng))
    } else {
       let slct_cols = creat_argv.force_to_ary(argv.C);
       let order_by  = creat_argv.force_to_ary(argv.r);
       if(slct_cols.length ===0) {slct_cols=null} else {} 
       let paramd = {
        tbl       : argv.t,
        cond      : argv.c,
        srch_ptrn : argv.s  ,
        oper      : argv.o,
        ////
        offset    :   argv.O,
        limit     :   argv.L,
        order_by  ,                                 //['update_at','DESC','id','ASC'],
        slct_cols ,                              //或者是一个数组  null 表示*
        desc      :  argv.D,
       }
       if(argv.a === 'select_with_match') { 
           p = _eng.select_with_match(argv.N,paramd);   
       } else if(argv.a === 'select_with_all') {
           paramd.total = argv.T;
           p = _eng.select_with_all(argv.N,paramd);
       } else {
       }
    }
    ////-----
    if(p) {
            p.then(
                r => fshow(r)
            ).catch(
                err=>console.log(err)
            ).finally(
                ()=>process.exit()
            )
    } else {}
}
